<template>
    <div id="q-app">
        <MainLayout v-if="RenderLayout"/>
        <EmptyLayout v-else/>
    </div>
</template>
<script lang="ts">
import {Component, Vue, Watch} from 'vue-property-decorator';
import MainLayout from "layouts/MainLayout.vue";
import EmptyLayout from "layouts/EmptyLayout.vue";


@Component({
    components: {EmptyLayout, MainLayout}
})
export default class App extends Vue {


    get RenderLayout() {
        const n = this.$route.name;
        return this.LoggedIn && n !== 'home' && n != 'register';
    }


    @Watch('$route')
    async OnRouteChange(to: any) {
        if (this.$auth.isAuthenticated && this.$coreAuth.user != null) {
            this.$coreAuth.ChangeKey()
            if (this.PersistentStore.StoreValue.project == '' && !to.meta.projectless) {
                await this.$router.push('/project');
            }
        }
    }

    async created() {

        const darkMode = localStorage.getItem('dark-mode') ?? 'false';
        const dm = JSON.parse(darkMode);

        this.$q.dark.set(dm);

        this.$q.iconMapFn = (iconName) => {
            if (iconName.startsWith('icofont-')) {
                return {
                    cls: iconName
                }
            }
        }

        if (window.location.search.includes("code=") && window.location.search.includes("state=")) {
            const {appState} = await this.$auth.HandleRedirectCallback() as any;
            this.$auth.redirectCallback(appState);
        }

        await this.$auth.Authenticate();
        await this.OnRouteChange(this.$route);
        // Orientation.lock();
    }
}
</script>
